//////////////////////////////////////////
// RenamerProc.h
// Copyright (c) 05/06/2020 by ECCSkelton
//////////////////////////////////////////

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//EBhEbZ[W֐
/////////////////////////////////
bool CMyWnd::OnInit(WPARAM wParam, LPARAM lParam) {

	//IDC_PATHɃc[`bv
	g_Tip.SetToolTip(m_hWnd, IDC_PATH, L"tH[_[IĂ", TRUE);
	//t@CύX_CAO{^𖳌
	CheckList();
	//wvt@C̐ݒ
	CARG arg;
	g_HelpFile = arg.Path();
	g_HelpFile = g_HelpFile + L"\\RenamerHelp.chm";
	//Ot@CtH[_[̑݊mFiȂꍇ͍쐬j
	g_LogPath = arg.Path();
	g_LogPath = g_LogPath + L"\\RenameLog\\";
	if(!PathFileExistsW(g_LogPath.ToChar()))
		CreateDirectoryW(g_LogPath.ToChar(), NULL);
	//hbOAhhbv
	DragAcceptFiles(m_hWnd, TRUE);
	return TRUE;
}

bool CMyWnd::OnDropFiles(WPARAM wParam, LPARAM lParam) {

	//ւǉ̊mF
	int res = MessageBoxW(m_hWnd, L"t@Cւ܂i͂jA܂͒ǉ܂ij",
						L"ւǉ̊mF", MB_YESNOCANCEL | MB_ICONQUESTION);
	if(res == IDYES) {
		//g_Path
		g_Path = L"";
		//Xg{bNX|
		int i = SendItemMsg(IDC_LISTBOX, LB_GETCOUNT, 0, 0);
    	if(i > 0)
			for(--i; i >= 0; i--)
				SendItemMsg(IDC_LISTBOX, LB_DELETESTRING, (WPARAM)i, 0);
	}
	else if(res == IDCANCEL)
		return FALSE;
	//hbOAhhbvꂽt@C擾Ə
	WCHAR fn[MAX_PATH];
	//hbOAhhbvꂽt@C̐擾
	int num = DragQueryFileW((HDROP)wParam, 0xFFFFFFFF, NULL, 0);
	//hbOAhhbvꂽt@C擾Ə
	for(int i = 0; i < num; i++) {
		DragQueryFileW((HDROP)wParam, i, fn, sizeof(fn));
		//Xg{bNXɃt@Cǉ
		WCHAR** pathname = GetPathName(fn);
		if(*g_Path.ToChar() && g_Path != pathname[0])
			MessageBoxW(m_hWnd, L"قȂtH[_[̃t@Cǉł܂B", pathname[1], MB_OK | MB_ICONERROR);
		else {
			if(!*g_Path.ToChar()) {
				g_Path = pathname[0];
				SendItemMsg(IDC_PATH, WM_SETTEXT, 0, (LPARAM)pathname[0]);
				g_Tip.UpdateText(pathname[0]);
			}
			SendItemMsg(IDC_LISTBOX, LB_ADDSTRING, 0, (LPARAM)pathname[1]);
		}
	}
	DragFinish((HDROP)wParam);
	//t@CύX{^L
	CheckList();
	return TRUE;
}

bool CMyWnd::OnClose(WPARAM wPram, LPARAM lParam) {

	//ImF
	if(MessageBoxW(m_hWnd, L"I܂", L"ImF",
				MB_YESNO | MB_ICONINFORMATION) == IDYES) {
	//DestroyWindowAPostQuitMessageĂ΂
		Destroy();
		return TRUE;
	}
	else
		return FALSE;
}

bool CMyWnd::OnDestroy(WPARAM wPram, LPARAM lParam) {

	//_CAOx[X̏ꍇ͂ꂪKv
	PostQuitMessage(0);
	return TRUE;
}

/////////////////////////////////
//EBhECMyWnd̊֐̒`
//j[ځARg[֐
/////////////////////////////////
bool CMyWnd::OnSelect() {

	//tH[_[IƃtH[_[t@C̃Xg{bNXo^
	WCHAR *fp = g_CmnDlg.GetPath(m_hWnd, L"t@CpX̑I");
	if(fp)
		g_Path = fp;
	else {
		MessageBoxW(m_hWnd, L"pXIĂ܂", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	//Xg{bNX\
	RenewListBox();
	//g_OrgFilesXVAt@CύX_CAO{^L
	CheckList();
	return TRUE;
}

bool CMyWnd::OnListBox(WPARAM wParam) {

	if(HIWORD(wParam) == LBN_SELCHANGE) {
		//|bvAbvj[ǂ݂
		HMENU hMenu = LoadMenuW(m_hInstance, L"IDM_POPUP");
		HMENU hPopupMenu = GetSubMenu(hMenu, 0);
		//|bvAbvj[̕\
		POINT pt;
		GetCursorPos(&pt);
		TrackPopupMenu(hPopupMenu, TPM_LEFTALIGN | TPM_LEFTBUTTON,
					  pt.x, pt.y, 0, m_hWnd, NULL);
		//j[\[X̊J
		DestroyMenu(hMenu);
		return TRUE;
	}
	return FALSE;
}

bool CMyWnd::OnReplace() {

	subdlg.DoModal(m_hWnd, L"IDD_SUB", GetInstance());
	//ʊmF̂߂ɃJgtH[_[\
	RenewListBox();
	return TRUE;
}

bool CMyWnd::OnSerial() {

	sub2dlg.DoModal(m_hWnd, L"IDD_SUB", GetInstance());
	//ʊmF̂߂ɃJgtH[_[\
	RenewListBox();
	return TRUE;
}

bool CMyWnd::OnHelp() {

	CSTR cmd = L"hh";
	if(ShellExecuteW(m_hWnd, L"open", cmd.ToChar(), g_HelpFile.ToChar(), NULL, SW_SHOWNORMAL) <= (HINSTANCE)32) {	//L"open" or L"runas"
		MessageBoxW(m_hWnd, L"wvt@CJ܂ł", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else
		return TRUE;
}

bool CMyWnd::OnExit() {

	SendMsg(WM_CLOSE, 0, 0);
	return TRUE;
}

bool CMyWnd::OnDel() {

	int sel = SendItemMsg(IDC_LISTBOX, LB_GETCURSEL, 0, 0);
	SendItemMsg(IDC_LISTBOX, LB_DELETESTRING, (WPARAM)sel, 0);
	CheckList();
	return TRUE;
}

bool CMyWnd::OnAdd() {

	WCHAR *fn = g_CmnDlg.GetFileName(m_hWnd, L"ׂẴt@C\0*.*\0\0", TRUE);
	if(!fn) {
		MessageBoxW(m_hWnd, L"LZ܂B", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	WCHAR** pathname = GetPathName(fn);
	if(*g_Path.ToChar() && g_Path != pathname[0]) {
		MessageBoxW(m_hWnd, L"قȂtH[_[̃t@Cǉł܂B", pathname[1], MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		SendItemMsg(IDC_LISTBOX, LB_ADDSTRING, 0, (LPARAM)pathname[1]);
		CheckList();
		return TRUE;
	}
}

////////////////////
//[U[֐`
/////////////////////////////////
//pathnamepathnameɕ
//|C^[zԂ
/////////////////////////////////
WCHAR** CMyWnd::GetPathName(WCHAR* pathname) {

	static WCHAR buffer[MAX_PATH], *ret[2];
	lstrcpyW(buffer, pathname);
	WCHAR* lastBackSlash;
	for(WCHAR* cp = buffer; *cp; cp++)
		if(*cp == '\\')
			lastBackSlash = cp;
	*lastBackSlash = L'\0';
	ret[0] = buffer;
	ret[1] = ++lastBackSlash;
	return ret;
}

/////////////////////////////////////////
//path̃t@CXg{bNXɕ\
//g_OrgFilesɃt@CR}
//؂蕶ŋL^
/////////////////////////////////////////
void CMyWnd::RenewListBox() {

	//Xg{bNX|
	int i = SendItemMsg(IDC_LISTBOX, LB_GETCOUNT, 0, 0);
    if(i > 0) {
		for(--i; i >= 0; i--)
			SendItemMsg(IDC_LISTBOX, LB_DELETESTRING, (WPARAM)i, 0);
	}
	//Xg{bNXɃJgtH[_[̃t@C\
	CSTR path = g_Path + L"\\*.*";		//t@Cx[XɂȂƋ@\Ȃ
	MakeOrgFileList(path.ToChar());
	//ύX\t@C̓o^
	ListFiles(m_hWnd, IDC_LISTBOX, &g_OrgFiles);
}

/////////////////////////////////////////
//JgtH[_[̃t@CXg
//{bNXɕ\
/////////////////////////////////////////
bool CMyWnd::MakeOrgFileList(WCHAR* path) {

	WIN32_FIND_DATAW fd;
	HANDLE hFind = FindFirstFileW(path, &fd);
	int i = 0;				//t@CJE^[
	if (hFind == INVALID_HANDLE_VALUE) {
		MessageBoxW(m_hWnd, L"t@C擾s", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		g_OrgFiles = L"";
		do {
			if (fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY);	// Directory
			else {													// Files
				g_OrgFiles = g_OrgFiles + L"\"" + fd.cFileName + L"\",";	//pŊ
			}
		} while (FindNextFileW(hFind, &fd));
	}
	FindClose(hFind);
	return (bool)i;
}

///////////////////////////////////////////////
//Xg{bNX̃t@C𐔂Ag_OrgFiles
//XVAt@CύX{^L
///////////////////////////////////////////////
bool CMyWnd::CheckList() {

	//Xg{bNX̃t@CmF
	int n = SendItemMsg(IDC_LISTBOX, LB_GETCOUNT, 0, 0);
	if(n) {
		//IDC_PATHɃt@C\Ac[`bv
		SendItemMsg(IDC_PATH, WM_SETTEXT, 0, (LPARAM)g_Path.ToChar());
		g_Tip.UpdateText(g_Path.ToChar());
		//g_OrgFilesXV
		g_OrgFiles = L"";
		WCHAR str[MAX_PATH];
		for(int i = 0; i < n; i++) {
			g_OrgFiles = g_OrgFiles + L"\"";
			SendItemMsg(IDC_LISTBOX, LB_GETTEXT, i, (LPARAM)str);
			g_OrgFiles = g_OrgFiles + str + L"\",";
		}
		//t@CύX_CAO{^L
		EnableWindow(GetDlgItem(m_hWnd, IDC_REPLACE), TRUE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_SERIAL), TRUE);
	}
	else {
		//IDC_PATHƃc[`bv
		g_Path = L"";
		SendItemMsg(IDC_PATH, WM_SETTEXT, 0, (LPARAM)g_Path.ToChar());
		g_Tip.UpdateText(L"tH[_[IĂ");
		//t@CύX_CAO{^𖳌
		EnableWindow(GetDlgItem(m_hWnd, IDC_REPLACE), FALSE);
		EnableWindow(GetDlgItem(m_hWnd, IDC_SERIAL), FALSE);
	}
	return (bool)n;
}

//////////////////////////////
//SUB_CAO̊֐̒`
//Rg[֐
//////////////////////////////
bool SUBDLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//u啶ʁvɃ`FbN
	SendItemMsg(IDC_CHECKUORL, BM_SETCHECK, BST_CHECKED, (LPARAM)0);
	//uϊsv{^𖳌ɂ
	EnableWindow(GetDlgItem(m_hWnd, IDOK), FALSE);
	//ύX\t@C̓o^
	ListFiles(m_hWnd, IDC_LISTBOX, &g_OrgFiles);
	return TRUE;
}

bool SUBDLG::OnPreview() {

	//u啶ʁv̏ԂmFAL^UorLɋL^
	LRESULT UorL = SendItemMsg(IDC_CHECKUORL, BM_GETCHECK, 0, (LPARAM)0);
	//Xg{bNX猳̃t@C擾
	int n = SendItemMsg(IDC_LISTBOX, LB_GETCOUNT, 0, 0);
    if(!n) {
		MessageBoxW(m_hWnd, L"t@C܂", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		//Auƍƃobt@
		WCHAR ToRep[MAX_PATH], RepWith[MAX_PATH], buff[MAX_PATH];
		//GfBbg{bNX擾
		GetWindowTextW(GetDlgItem(m_hWnd, IDC_TOREPLACE), ToRep, (LPARAM)MAX_PATH);
		if(!*ToRep) {
			MessageBoxW(m_hWnd, L"uΏە͂łB", L"G[", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		else
			if(UorL == BST_UNCHECKED)	//啶ʂȂꍇAToRep
				CharLowerW(ToRep);
		//uGfBbg{bNX擾
		GetWindowTextW(GetDlgItem(m_hWnd, IDC_REPLACEWITH), RepWith, (LPARAM)MAX_PATH);
		if(!*RepWith) {
			MessageBoxW(m_hWnd, L"u͂łB", L"G[", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		//̃R}i','j؂t@CXg(g_OrgFiles)g_OldFiles
		g_OldFiles = g_OrgFiles;	//
		g_OrgFiles = L"";			//
		g_NewFiles = L"";			//
		CSTR Name, work;			//R}؂t@C؂oϐƏϊpϐ
		for(int i = 0; g_OldFiles.Next(Name); i++) {
			work = Name;							//NameێAworkƗpɎg
			if(UorL == BST_UNCHECKED)				//啶ʂȂȂ΁A
				CharLowerW(work.ToChar());			//work̕
			//uāAVt@CXg(g_NewFiles)R}i','j؂ō쐬
			if(InstrRep(work.ToChar(), ToRep, RepWith, buff)) {
				g_OrgFiles = g_OrgFiles + L"\"";			//p
				g_OrgFiles = g_OrgFiles + Name.ToChar();	//uΏیt@C
				g_OrgFiles = g_OrgFiles + L"\",";			//pƃR}؂
				g_NewFiles = g_NewFiles + L"\"";			//p
				g_NewFiles = g_NewFiles + buff;				//ύXt@C
				g_NewFiles = g_NewFiles + L"\",";			//pƃR}؂
			}
		}
		ListFiles(m_hWnd, IDC_LISTBOX, &g_NewFiles);
		//uϊsv{^Lɂ
		EnableWindow(GetDlgItem(m_hWnd, IDOK), TRUE);
		return TRUE;
	}
}

bool SUBDLG::OnOk() {

	if(MessageBoxW(m_hWnd, L"RenameLogtH[_[Shift-JISŁi͂j\r\n܂UTF-8Łij\r\nOt@CL^܂B",
					L"Ot@C`mF", MB_YESNO | MB_ICONQUESTION) == IDYES) {
		if(RenameFiles(TRUE))
			MessageBoxW(m_hWnd, L"RenameLogtH[_[ɃOt@CSJISŋL^܂B", L"OۑmF", MB_OK | MB_ICONINFORMATION);
		else
			MessageBoxW(m_hWnd, L"t@CύXɎs܂B", L"G[", MB_OK | MB_ICONERROR);
	}
	else {
		if(RenameFiles(FALSE))
			MessageBoxW(m_hWnd, L"RenameLogtH[_[ɃOt@CUTF-8ŋL^܂B", L"OۑmF", MB_OK | MB_ICONINFORMATION);
		else
			MessageBoxW(m_hWnd, L"t@CύXɎs܂B", L"G[", MB_OK | MB_ICONERROR);
	}
	EndModal(TRUE);
	return TRUE;
}

bool SUBDLG::OnCancel() {

	EndModal(FALSE);
	return TRUE;
}

///////////////////
//[U[`֐
///////////////////////////////////////////////////////////////////
//iOldǰiToFindjuiToReplacej
//PuǍʂViNewjɏ
//y߂lz
//uɐꍇF񂪌AhX
//uɎsꍇF0
///////////////////////////////////////////////////////////////////
WCHAR* SUBDLG::InstrRep(WCHAR* Old, WCHAR* ToFind, WCHAR* ToReplace, WCHAR* New) {

	if(!(*Old & *ToFind & *ToReplace))			// Error check
		return 0;
	WCHAR *p1 = Old, *p2 = ToFind, *findp = 0;	// Setting work pointers
	do {
		if(findp) {								// In the course of matching
			if(!*p2) {							// If Matching completes,
				int i;
				for(i = 0; i < (findp - Old); i++)
					New[i] = Old[i];			// Copy Old to New till findp
				New[i] = 0;						// Add null termination
				wcscat(New, ToReplace);			// Copying ToReplace in place of ToFind
				wcscat(New, p1);				// Copying the rest of Old
				return findp;
			}
			else 								// In case that Matching fails
				if(*p1 != *p2) {
					p2 = ToFind;				// Reset pointers and repeat
					findp = 0;
				}
		}
		if(*p1 == *p2) {						// If matching begins,
			if(!findp)							// For the 1st time,
				findp = p1;						// Record p1 where ToFind is found
			++p2;								// p2 proceeds, as p1 does
		}
	} while(*p1++);
	return 0;
}

//////////////////////////////
//SUB2_CAO̊֐̒`
//Rg[֐
//////////////////////////////
bool SUB2DLG::OnInit(WPARAM wParam, LPARAM lParam) {

	//_CAO^Cg̕ύX
	SendMsg(WM_SETTEXT, 0, (LPARAM)L"t@CŘAԕt");
	//gȂRg[B
	ShowWindow(GetDlgItem(m_hWnd, IDC_CHECKUORL), SW_HIDE);
	ShowWindow(GetDlgItem(m_hWnd, IDC_REPLACEWITH), SW_HIDE);
	SendItemMsg(IDC_LABEL1, WM_SETTEXT, 0, (LPARAM)L"t@C");
	SendItemMsg(IDC_LABEL2, WM_SETTEXT, 0, (LPARAM)L"Fgq(.*)͕tȂ");
	//uϊsv{^𖳌ɂ
	EnableWindow(GetDlgItem(m_hWnd, IDOK), FALSE);
	//ύX\t@C̓o^
	ListFiles(m_hWnd, IDC_LISTBOX, &g_OrgFiles);
	return TRUE;
}

bool SUB2DLG::OnPreview() {

	//Xg{bNX猳̃t@C擾
	int n = SendItemMsg(IDC_LISTBOX, LB_GETCOUNT, 0, 0);
    if(!n) {
		MessageBoxW(m_hWnd, L"t@C܂", L"G[", MB_OK | MB_ICONERROR);
		return FALSE;
	}
	else {
		//t@CƘAԕiL"(???)\0"|6j
		WCHAR ToRep[MAX_PATH], num[6];
		//GfBbg{bNX擾
		GetWindowTextW(GetDlgItem(m_hWnd, IDC_TOREPLACE), ToRep, (LPARAM)MAX_PATH);
		if(!*ToRep) {
			MessageBoxW(m_hWnd, L"t@C͂łB", L"G[", MB_OK | MB_ICONERROR);
			return FALSE;
		}
		//̃R}i','j؂t@CXg(g_OrgFiles)g_OldFiles
		g_OldFiles = g_OrgFiles;	//
		g_NewFiles = L"";			//
		CSTR Name;					//R}؂t@C؂oϐ
		for(int i = 0; g_OldFiles.Next(Name); i++) {
			//gq΂̃AhXAȂ0foundɓ
			WCHAR* found = Name.ToChar() + lstrlenW(Name.ToChar());
			while(found > Name.ToChar() && *found != L'.')
				found--;
			if(found == Name.ToChar())
				found = 0;
			//uāAVt@CXg(g_NewFiles)R}i','j؂ō쐬
			g_NewFiles = g_NewFiles + L"\"";		//p
			g_NewFiles = g_NewFiles + ToRep;		//ύXt@Cigqj
			wsprintfW(num, L"(%03d)", i);			//'0'ŃTvXꂽA
			g_NewFiles = g_NewFiles + num;			//ύXt@C
			if(found)								//gqt@C
				g_NewFiles = g_NewFiles + found;	//u'.'ȉgqvt
			g_NewFiles = g_NewFiles + L"\",";		//pƃR}؂
		}
		ListFiles(m_hWnd, IDC_LISTBOX, &g_NewFiles);
		//uϊsv{^Lɂ
		EnableWindow(GetDlgItem(m_hWnd, IDOK), TRUE);
		return TRUE;;
	}
}
